rev1093 doesn't work: Fixed migration 87 (mysql: TEXT column can’'t have a default value).
2008-03-02 13:24 - Chaoqun Zou
Resolution: Affected version:

Description

my enviroment is:

windows xp

rails 2.0.2

mysql 5.0.45

redmine r1183

in 001_setup.rb line174

create_table "projects”, :force => true do |f|

t.column "name", :string, :limit => 30, :default => "", :null => false
t.column "description", :string, :default => "", :null => false

this means column "description” will have a default value of ™"

and

in ruby\lib\ruby\gems\1.8\gems\activerecord-2.0.2\lib\active_record\connection_adapters\mysqgladapter.rb line429
def change_column(table_name, column_name, type, options = {}) #:nodoc:

unless options_include_default?(options)

if column = columns(table_name).find { |c| c.name == column_name.to_s}
options[:default] = column.default

else

raise "No such column: #{table_name}.#{column_name}"

end

end

this means when use change_column in 087_change_projects_description_to_text.rb
change_column :projects, :description, :text, :null => true

active_record will find column description's default value and add it to the sql:

ALTER TABLE “projects’ CHANGE “description” "description” text DEFAULT "

which will fail, info:

rake aborted!

Mysql::Error: BLOB/TEXT column 'description’ can't have a default value: ALTER TABLE “projects” CHANGE "description
“description” text DEFAULT "

so | think just remove the "default => ""
Or should | use mysql5.1?

statement from 087_change_projects_description_to_text.rb will not solve the problem.

Associated revisions

Revision 1189 - 2008-03-05 10:16 - Jean-Philippe Lang
Fixes migration 87 error when running MySQL with STRICT_TRANS_TABLES on (#771).

History

#1 - 2008-03-03 09:47 - Michael Pirogov
- Assignee set to Jean-Philippe Lang

After an successfull migrate still got this:

Processing IssuesController#show (for 81.88.112.156 at 2008-03-03 11:27:05) [GET]
Session ID: 523al278c75bda26e60£67216b4f63ff
Parameters: {"action"=>"show", "id"=>"77", "controller"=>"issues"}

Rendering templateissues/show.rhtmllayoutfalse within layouts/base
Rendering issues/show.rhtml

ActionView::TemplateError (undefined method “description' for #<Attachment:0xb6e543e8>) on line #4 of app/view
s/attachments/_links.rhtml:

1: <div class="attachments">

2: <% for attachment in attachments %>

3: <p><%= link_to attachment.filename, {:controller => 'attachments', :action => 'download', :id => attachment
}, :class => 'icon icon-attachment' -%>

4: <%= h(" - #{attachment.description}") unless attachment.description.blank? %>

5: <span class="size"> (<%= number_to_human_size attachment.filesize %>)</span>

6: <% if options[:delete_url] %>

7 <%= link_to image_tag('delete.png'), options[:delete_url].update({:attachment_id => attachment}),

/usr/lib/ruby/gems/1.8/gems/activerecord-1.15.6/1ib/active_record/base.rb:1863:in ‘method_missing'

#2 - 2008-03-03 14:16 - Chaoqun Zou

- Status changed from New to Resolved

to Michael:
| think your problem in issues controller is not the same question with my migration error.

to JP Lang:

| have resolved my migration error by some irregular method. Please note:

1. MySQL 5.0 and 5.1 will not allow default value for BLOB/TEXT column.

2. If MySQL is working in strict mode, it will report an error on a TEXT column's default value and stop. While if its work mode is not strict
mode(maybe sqgl_mode=""), it will just give out a warning instead of an error and the sgl command will be executed successfully.

3. MySQL 5.0 binary installed on windows will work in strict mode in default. While it will not work in strict mode on linux compiled from source.(I'm not
sure with linux because | use windows xp)

4. So maybe most of the redmine's users wouldn't encounter this problem...

So, to windows users of redmine, if you have encountered my problem, there is a solution:

. find your mysql server's ini file, will be "MySQL\MySQL Server 5.0\my.ini" in default.

. locate this line: sql-mode="STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION"

. add a "#" to the head: #sql-mode="STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION"
. restart mysql server

. run rake db:migrate, it should succeed this time

. change the my.ini file back and restart mysql server

o0 WN =

I'm sorry that | cann't find a more reasonable solution for this problem.

#3 - 2008-03-05 10:19 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Migration 87 is fixed by r1189.
It now runs fine with STRICT_TRANS_TABLES on.

Michael: | think you get this error because you didn't apply the migration 89 (the last one) which adds a description field to the attachments table.
